import 'reflect-metadata';
import { Context } from './base_context_class';
import { Application } from '../framework';
export declare type MethodType = 'head' | 'options' | 'get' | 'put' | 'patch' | 'post' | 'delete' | 'all' | 'resources' | 'register' | 'redirect';
export interface RouterMetadataType {
    name?: string;
    method?: MethodType;
    url?: string | RegExp | string[] | RegExp[] | ((app: Application) => string);
    descrption?: string;
}
export declare type GetMiddlewareType = (app: Application) => (Function | Function[]);
export interface RouterType extends RouterMetadataType {
    typeClass: any;
    typeGlobalName: string;
    functionName: string;
    paramTypes: {
        name: string;
        type: any;
    }[];
    returnType: any;
    call: () => (ctx: Context) => any;
    beforeMiddleware: GetMiddlewareType[];
    afterMiddleware: GetMiddlewareType[];
}
export declare function FromCustom(custom: (ctx: Context, name: string) => any, paramName?: string): ParameterDecorator;
export declare function FromBody(paramName?: string): ParameterDecorator;
export declare function FromParam(paramName?: string): ParameterDecorator;
export declare function FromQuery(paramName?: string): ParameterDecorator;
export declare function beforeMiddware(middwares: GetMiddlewareType | GetMiddlewareType[]): MethodDecorator;
export declare function afterMiddware(middwares: GetMiddlewareType | GetMiddlewareType[]): MethodDecorator;
export declare function routerMetadata(data?: RouterMetadataType): MethodDecorator;
export declare function getRouters(): RouterType[];
